Hooks:PreHook(HuskPlayerBase, "set_upgrade_value", "PlayerInfo_HuskPlayerBase_pre_set_upgrade_value",
    function(self, category, upgrade, level)
        local unit = self._unit
        if not unit then
            return
        end

        local network_session = managers.network:session()
        if not network_session then
            return
        end

        local peer = network_session:peer_by_unit(unit)
        if not peer then
            return
        end

        local teammate_id = managers.criminals:character_data_by_peer_id(peer:id()).panel_id

        if category == UpgradesTweakData.CLEAR_UPGRADES_FLAG then
            PlayerInfo:ClearPlayerUpgrades(teammate_id)
        else
            PlayerInfo:UpsertPlayerUpgrade(teammate_id, category, upgrade, level, true)
        end
    end
)
